package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.Goods;
import com.ff.weijinxiao.repository.GoodsRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class GoodsService {

    @Resource
    private GoodsRepository goodsRepository;

    /**
     * 创建实体
     *
     * @param goods
     */
    public Goods saveGoods(Goods goods) {
        return goodsRepository.save(goods);
    }

    public Goods findByNameAndUid(String name, String uid) {
        return goodsRepository.findByNameAndUid(name, uid);
    }
    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public Goods findById(Integer id) {
        Optional<Goods> optional = goodsRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public Goods findByOnlyID(String onlyID) {
        return goodsRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        goodsRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<Goods> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return goodsRepository.findAll(SpecificationUtil.buildSpecification(param, Goods.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<Goods> findList(Map<String, Object> param) {
        return goodsRepository.findAll(SpecificationUtil.buildSpecification(param, Goods.class));
    }

}
